#ifndef QB_TIME_EDITORS_H
#define QB_TIME_EDITORS_H

#include "QbEditors.h"

#include <QObject.h>
#include "qt_version.h"
#include <QStatusBar>

class QbTimeIntervalEditor:public QbEditor
{
	Q_OBJECT
			
	public:
		QbTimeIntervalEditor( QdObject_var dobj, QWidget *parent=0, const char *name=0 );
		QdTimeInterval_var _time_interval_var;
		
		virtual void save(Vostream&);
		virtual void restore(Vistream&);
		
		void set_time_interval(const QmjdTimeInterval& tintv, bool setViewRangeToo=false);

		bool get_time_interval( QmjdTimeInterval& tintv ) const;

        void set_view_range(const QmjdTimeInterval& tintv);

		double get_duration();
		
		void setReadOnly(bool readOnly);
		
        TimeIntervalWidget * interval_edit;
        
	public slots:
		
		void setData(QdObject_var dobj);
		
		void updateTI();
	
	signals:
		
		
	
};

class QbEventTableEditor:public QbEditor
{
	Q_OBJECT
			
	public:
		QbEventTableEditor( QdObject_var dobj, QWidget *parent=0, QString name="Events" );
		
		QdTimeIntervalSeq_var _event_table_var;
		
		bool get_time_interval( QmjdTimeInterval& tintv ) const;

        void set_view_range(const QmjdTimeInterval& tintv);

		double get_duration();
				
		void setReadOnly(bool readOnly);

        TimeIntervalWidget * interval_edit;
        
	public slots:
		
		void setData(QdObject_var dobj);
		
		
		void updateForRec();
	
	signals:
		
	
};

class QbuLineEdit:public QLineEdit{
	Q_OBJECT
	public:
		QbuLineEdit(QWidget* parent=0,const char* name=0):
				QLineEdit(parent){;}
 
	protected:
		QString _old_text;
		void focusOutEvent(QFocusEvent *e);

	public slots:
		void setText(const QString& txt)
		{ _old_text=text(); QLineEdit::setText(txt);}
	signals:
		void focusOut();

};


#endif
