#ifndef QCALC_TIMELINE_H
#define QCALC_TIMELINE_H

#include "qcalcCommon.h"

class TimeLine
{
	public:
		bool fromData;
		bool regularTT;
		QString fromObjString;
		QString TTString;
		
		TimeLine();
		
// 		QdTimeSeq_var getTimeTags();
//         QdTimeInterval_var getInterval();
//         QdTimeInterval_var getIntervalFromData();
};

class TimeLineHandler: public QObject
{
	Q_OBJECT
	
	public:
		TimeLineHandler();
		
		virtual ~TimeLineHandler();
		
		TimeLine* getTimeLine(const QString& name);
		
		bool deleteTimeLine(const QString& name);
		
		bool addTimeLine(const QString& name, bool fromData=false, bool regularTT=false, const QString& fromObjString="", const QString TTString="");
		
		inline TimeLine* getDefaultTimeLine(){return timeLines[0];};
		
		QList<QString> getNames();
		
		// Gets a time line according to its parameters, if it exists. As a TL can exist with a specific name, checks if the name corresponds to anything existing and matching, first.
		QString getTimeLine(bool fromData, bool regularTT, const QString& fromObjString, const QString TTString, const QString& name=QString());
		
		
	signals:
		
		void deletedTimeLine(const QString&);
		
		void addedTimeLine(const QString&);
		
		void timeLineChanged(const QString&);
				
	protected:
		
		QVector<QString> names;
		QVector<TimeLine*> timeLines;
};

#endif
