#include "qOperators.h"


QdObject_var QdInvers( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult;

    if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
        return ( qdResult );
    }

	string     attrPtr;
	string     stringBuf;

	// do arithmetic...
	try
	{
		qdResult = invert( qdOperand1 );
	}
	catch( Exception &e )
	{
		QcalcAppendTextDisplay ( e.msg().c_str() );
		QcalcAppendTextDisplay( "The operation Inverse is not yet supported  for this input type");
		rqstrErrorMsg = QString( "The operation Inverse is not yet supported for this input type");
		return ( qdResult );
	}

	if ( qdResult.is_nil() )
	{
		QcalcAppendTextDisplay( "Arithmetic>> Inverse is not available for this input" );
		rqstrErrorMsg = QString( "Arithmetic>> Inverse is not available for this input" );
		return ( qdResult );
	}

	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( qdOperand1 );
	if ( !qd0.is_nil() ) qdResult->change_xref(DEPEND_0 , qd0 );

	// Set QSAS essential attributes

	// Frame
	QuSetFrame( qdResult, "scalar" );

	// UNITS
	attrPtr = QuGetAttrText( "UNITS", qdOperand1 );
	if ( !attrPtr.empty() )
	{
		stringBuf = "(";
		stringBuf += attrPtr ;
		stringBuf += ")^-1";
		QuSetTxtAttr( "UNITS", stringBuf.c_str(), qdResult );
	}
	
	// SI_conversion
	attrPtr = QarSIConv_inverse( qdOperand1 );
	if ( !attrPtr.empty() )
	{
		QuSetTxtAttr( "SI_conversion", attrPtr.c_str(), qdResult );
	}

	// LABLAXIS
	QString labl_s = "1 / ";
	labl_s += QuGetAttrText( "LABLAXIS", qdOperand1 ).c_str();
	QuSetTxtAttr( "LABLAXIS", labl_s.toLatin1().data(), qdResult );

    return ( qdResult );
}




