#include "qOperators.h"

QdObject_var QdLog10( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult;

    if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
        return ( qdResult );
    }


	// do arithmetic...
	try
	{
		qdResult = log10( qdOperand1 );
	}
	catch( Exception &e )
	{
		QcalcAppendTextDisplay ( e.msg().c_str() );
		QcalcAppendTextDisplay( "The operation log10 is not yet supported between these input types");
		rqstrErrorMsg = QString( "The operation log10 is not yet supported between these input types");
		return ( qdResult );
	}


	if (qdResult.is_nil())
	{
		QcalcAppendTextDisplay( "Arithmetic>> Log is not supported between these input types" );
		rqstrErrorMsg = QString( "Arithmetic>> Log is not supported between these input types" );
		return ( qdResult );
	}

	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( qdOperand1 );
	if ( !qd0.is_nil() ) qdResult->change_xref(DEPEND_0 , qd0 );

	// Set QSAS essential attributes

   	// SI_conversion

   	// Not meaningfol for a log whatever the inputs

   	// UNITS

   	// Not meaningfol for a log whatever the inputs

 	// Frame
   	QuSetFrame( qdResult, "scalar" );

	// LABLAXIS
	QString labl_s = "log10(";
	labl_s += QuGetAttrText( "LABLAXIS", qdOperand1 ).c_str();
	labl_s += ")";
	QuSetTxtAttr( "LABLAXIS", labl_s.toLatin1().data(), qdResult );

    return ( qdResult );
}


