#include "qOperators.h"


 QdObject_var QdMod( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult;

    if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
	// The qdResult object is NULL at this point
        return ( qdResult );
    }

	string attrPtr;

	// do arithmetic...
	try
	{
		qdResult = mod( qdOperand1 );
	}
	catch( Exception &e )
	{
		QcalcAppendTextDisplay ( e.msg().c_str() );
		QcalcAppendTextDisplay( "The operation Mod is not yet supported for this input type");
		rqstrErrorMsg = QString( "The operation Mod is not yet supported for this input type");
		return ( qdResult );
	}

	if ( qdResult.is_nil() )
	{
		QcalcAppendTextDisplay( "Arithmetic>> Mod Operation is not supported for this input type" );
		rqstrErrorMsg = QString( "Arithmetic>> Mod Operation is not supported for this input type" );
		return ( qdResult );
	}

	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( qdOperand1 );
	if ( !qd0.is_nil() ) qdResult->change_xref(DEPEND_0 , qd0 );
	
	// Set QSAS essential attributes
	// SI_conversion
	attrPtr = QuGetAttrText( "SI_conversion", qdOperand1 );
	QuSetTxtAttr( "SI_conversion", attrPtr.c_str(), qdResult );

	// Frame
	// output is always a scalar
	QuSetFrame(qdResult , "scalar" );

	// UNITS
	attrPtr = QuGetAttrText( "UNITS", qdOperand1 );
	if( !attrPtr.empty() )
	{
		QuSetTxtAttr( "UNITS", attrPtr.c_str(), qdResult );
	}

	// LABLAXIS
	QString labl_s = "|";
	labl_s += QuGetAttrText( "LABLAXIS", qdOperand1 ).c_str();
	labl_s += "|";
	QuSetTxtAttr( "LABLAXIS", labl_s.toLatin1().data(), qdResult );

	return ( qdResult );
}





