#include "qOperators.h"


QdObject_var QdSqrt( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

    QdObject_var  qdResult;

    if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
        return ( qdResult );
    }

	string  attrPtr;

	// do arithmetic...
	try
	{
		qdResult = sqrt( qdOperand1 );
	}
	catch( Exception &e )
	{
		QcalcAppendTextDisplay ( e.msg().c_str() );
		QcalcAppendTextDisplay( "The operation sqrt is not yet supported for the input type");
		rqstrErrorMsg = QString( "The operation sqrt is not yet supported for the input type");
		return ( qdResult );
	}

	if (qdResult.is_nil())
	{
		QcalcAppendTextDisplay( "Arithmetic>> sqrt is not yet supported for the input type" );
		rqstrErrorMsg = QString( "Arithmetic>> sqrt is not yet supported for the input type" );
		return ( qdResult );
	}

	// Add timeline (or DEPEND_0) : Either timeline is safe if it exists
	QdObject_var qd0 = get_Depend_0( qdOperand1 );
	if ( !qd0.is_nil() ) qdResult->change_xref(DEPEND_0 , qd0 );

 	// Set QSAS essential attributes



	// SI_conversion
	attrPtr = QarSIConv_power(qdOperand1, 0.5);
	if( !attrPtr.empty() )
	{
		QuSetTxtAttr( "SI_conversion", attrPtr.c_str(), qdResult );
	}

	// UNITS
	attrPtr = QarUNITS_power(qdOperand1, 0.5);
	if( !attrPtr.empty() )
	{
		QuSetTxtAttr( "UNITS", attrPtr.c_str(), qdResult );
	}

 	// Frame
   	QuSetFrame(qdResult, "scalar" );

	// LABLAXIS
	QString labl_s = "sqrt(";
	labl_s += QuGetAttrText( "LABLAXIS", qdOperand1 ).c_str();
	labl_s += ")";
	QuSetTxtAttr( "LABLAXIS", labl_s.toLatin1().data(), qdResult );

    return ( qdResult );
}


