#include "qOperators.h"

QdObject_var QdUnits( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{
   QdRScalar_var factor;
   QdObject_var out_ptr;
   QdObject_var SI_target;
   
   if(qdOperand1.is_nil() || qdOperand2.is_nil()  ){
     QcalcAppendTextDisplay( "Invalid input object in Unit Conversion \n" );
     return out_ptr; 
   }
 
   string SIcTarget;
   QdString_var objStr=QdString_var::narrow(qdOperand2);
   if( objStr.is_nil() ){
      SIcTarget =  QuGetAttrText("SI_conversion", qdOperand2);
   }
   else{
     SIcTarget = objStr->c_str();
   }

   if( SIcTarget.empty() ){
     QcalcAppendTextDisplay( "Cannot get SI_conversion target for Unit Conversion\n" );
     return out_ptr; 
   }


// create output object
  
  try{
    out_ptr = QarConvertUnitsTo(qdOperand1, SIcTarget.c_str() ); 
    // this creates new converted object, copies xrefs across and sets SI_conversion
  }
  catch(Exception &e){
     QcalcAppendTextDisplay( e.msg().c_str() );
     return out_ptr;  
  }
 
  if ( out_ptr.is_nil() ) {
    QcalcAppendTextDisplay("Cannot convert object to chosen target units\n RHS of target SI_conversion should be of form ...\n");
    string attr_ptr = QuGetAttrText("SI_conversion", qdOperand1);
    size_t ptr = attr_ptr.find(">");
    QcalcAppendTextDisplay (attr_ptr.substr(ptr+1).c_str());	     
    return out_ptr; 
}
 
 
 // UNITS
  string targetUnits = QuGetAttrText("UNITS", qdOperand2);
  if(!targetUnits.empty()){
      QuSetTxtAttr("UNITS", targetUnits.c_str(), out_ptr);    
  }
  else{  // create Units from SI_conversion
    if( !SIcTarget.empty() ){
       size_t ptr = SIcTarget.find(">");
       if(ptr != string::npos) {
         string newUnits = SIcTarget.substr(ptr+1);
         if(atof(SIcTarget.c_str()) != 1){
           newUnits += " / ";
           newUnits += SIcTarget.substr(0, ptr);
         }
         QuSetTxtAttr("UNITS", newUnits.c_str(), out_ptr);
       }
     }
   }


   return ( out_ptr );
}




