#include <qsize.h>
#include "qcalc.h"
#include "qwui.h"


using namespace QSAS;


QcalcWindow * QCALCmakeWindow( QWidget *parent, const char * Title )
{
  if ( QCALC_widget == NULL )
  {
		QCALC_widget = new QcalcWindow( parent,Title );

		QCALC_widget->connect( parent, SIGNAL( saveSessionRequest( QString ) ), QCALC_widget, SLOT( saveSession(    QString ) ) );
		QCALC_widget->connect( parent, SIGNAL( restoreSessionRequest( QString ) ),   QCALC_widget, SLOT( restoreSession( QString ) ) );
		QCALC_widget->connect( parent, SIGNAL( clearListRequest() ),   QCALC_widget->_join_listview, SLOT( deleteAllItems() ) );
		QCALC_widget->setWindowTitle( Title) ;

		QCALC_widget->JoinBtn = new QPushButton( "Do", QCALC_widget->buttons_groupbox);
		QCALC_widget->JoinBtn->setFocusPolicy( Qt::StrongFocus );
		QCALC_widget->JoinBtn->setMinimumSize( QCALC_widget->JoinBtn->sizeHint() );
		QCALC_widget->connect( QCALC_widget->JoinBtn, SIGNAL(clicked()), QCALC_widget,   SLOT( DoCalculation() ) );
		QCALC_widget->buttons_groupbox->layout()->addWidget(QCALC_widget->JoinBtn);

		QCALC_widget->newCalcBtn = new QPushButton( "New Operation", QCALC_widget->buttons_groupbox );
		QCALC_widget->newCalcBtn->setFocusPolicy( Qt::StrongFocus );
		QCALC_widget->newCalcBtn->setMinimumSize( QCALC_widget->newCalcBtn->sizeHint() );
		QCALC_widget->connect( QCALC_widget->newCalcBtn, SIGNAL(clicked()), QCALC_widget->_join_listview, SLOT( insertVirtualItem() ) );
		QCALC_widget->buttons_groupbox->layout()->addWidget(QCALC_widget->newCalcBtn);

		QCALC_widget->dismissBtn = new QPushButton( "Dismiss",  QCALC_widget->buttons_groupbox );
		QCALC_widget->dismissBtn->setMinimumSize(QCALC_widget->dismissBtn->sizeHint());
		QCALC_widget->connect( QCALC_widget->dismissBtn, SIGNAL(clicked()), QCALC_widget, SLOT( close() ) );
		QCALC_widget->buttons_groupbox->layout()->addWidget(QCALC_widget->dismissBtn);

		QCALC_widget->_filename += QString("/saveSet");
		QCALC_widget->SAVE_EXTENSION = QString(".qs_calc");
		QCALC_widget->_filename += QCALC_widget->SAVE_EXTENSION;
		QCALC_widget->_saveset_filter=QString("calculator savesets (*.qs_calc)");
  }
 
  QCALC_widget->setAcceptDrops(TRUE);
  return QCALC_widget;

}

void QcalcShowCalc()
{	
  QCALC_widget->move(qsasGUISize().width(), 50);
  
  QCALC_widget->JoinBtn->setDefault( true );
  QCALC_widget->newCalcBtn->setDefault( false );
  QCALC_widget->dismissBtn->setDefault( false );

  QCALC_widget->show();
}



void QcalcAppendTextDisplay ( const char *text )
{
	if ( QCALC_widget == NULL )
	{

      QuMsgBar( "Calculator error, see console ", true );
      return;
    }

	if ( QCALC_widget->logArea == NULL )
	{
     	QuMsgBar( "Calculator error, see console ", true );
     	return;
	}

    QCALC_widget->logArea->append( text );
}


