#include "qcalcTimeLine.h"

TimeLine::TimeLine()
{
	fromData=true;
    regularTT=false;
    fromObjString="";
    TTString="";
}

TimeLineHandler::TimeLineHandler():
	QObject()
{
	TimeLine* defaultTimeLine=new TimeLine;
	names.clear();
	timeLines.clear();
	names.push_back("Default");
	timeLines.push_back(defaultTimeLine);
	
}

TimeLineHandler::~TimeLineHandler()
{
	for(int i=0; i<timeLines.size(); ++i)
	{
		delete timeLines[i];
	}
	timeLines.clear();
	names.clear();
}

TimeLine* TimeLineHandler::getTimeLine(const QString& name)
{
	int index=names.indexOf(name);
	if(index<0)
		return NULL;
	
	return timeLines[index];
}

bool TimeLineHandler::deleteTimeLine(const QString& name)
{
	int index=names.indexOf(name);
	if(index<=0)
		return false;

	names.remove(index);
	TimeLine* tl=timeLines[index];
	timeLines.remove(index);
	delete tl;
	emit deletedTimeLine(name);
	return true;
}

bool TimeLineHandler::addTimeLine(const QString& name, bool fromData, bool regularTT, const QString& fromObjString, const QString TTString)
{
	int index=names.indexOf(name);
	if(index>=0)
		return false;
	
	TimeLine* tl=new TimeLine;
	tl->fromData=fromData;
	tl->regularTT=regularTT;
	tl->fromObjString=fromObjString;
	tl->TTString=TTString;
	
	names.push_back(name);
	timeLines.push_back(tl);
	
	emit addedTimeLine(name);
	
	return true;
}

QList<QString> TimeLineHandler::getNames()
{
	QList<QString> res;
	res.clear();
	for(int i=0; i<names.size(); ++i)
	{
		res.push_back(names[i]);
	}
	return res;
}

QString TimeLineHandler::getTimeLine(bool fromData, bool regularTT, const QString& fromObjString, const QString TTString, const QString& name)
{
	TimeLine* tl;
	tl=getTimeLine(name);
	if(tl!=NULL)
	{
		if(tl->fromData==fromData && tl->regularTT==regularTT && tl->fromObjString==fromObjString && tl->TTString==TTString)
		{
			return name;
		}
	}
	for(int i=0; i<names.size(); ++i)
	{
		tl=timeLines[i];
		if(tl->fromData==fromData && tl->regularTT==regularTT && tl->fromObjString==fromObjString && tl->TTString==TTString)
		{
			return names[i];
		}
	}
	
	return QString();
}
