 
 /***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include <iostream>
#include <stdio.h>

#include "qt_version.h"
#include <QObject.h>
#include <qapplication.h>

#include <QMenu>
#include "qdi.h"


#include "qwui.h"
#include "qds.h"
#include "qie.h"
#include "qie_caa.h"
#include "qexui.h"
#include "qpui.h"
#include "qpolar.h"
#include "qsurface.h"
#include "q3dview.h"
#include "qcalc.h"
#include "qcalcWindow.h" 
#include "qjui.h"
#include "qprofui.h"
#include "PlotWindow.h"
#include "qprofile.h"
#include "qops.h"

 
 void  AddQwuiMenus();

 // menu helper class for main window
 
 class mainMenu : public QMenu
{
   Q_OBJECT

public:
   mainMenu(QWidget *parent=0, const char *name=0);
   void insertFileItems();
   void insertEditItems();
   void insertCalcItems();
   void insertHelpItems();
   void insertPlotItems();
   void insertPluginMenu();
   void insertProfilesItems();
   
   QDialog *objTypeSelector;
   arrDialog *arrTypeSelector;
   QString def_dir;

signals:
   
public slots:
	void DVOS_Test();
	void exportET();
	void menuOp(QAction* act);
	void refreshPlugins(bool first);
   void openDS();
   void openQIE();
   void openCAA();
   void openEvtTable();
   void openExport();
   void launchPlot();
   void launchPolarPlot();
   void launchSurfacePlot();
   void launch3DPlot();
   void launchJoin();
   void launchCalculator();
   void launchCalculatorPrototype();
   void openDataFile(const char *file);
   void launchEditProfile();
   void launchSelectProfile(QAction *);
   void updateProfileList();
	void launchPSD();
	void angleDepTo360();
	void angleDepTo180();
	void arrayTrace();
	void derivative();
	void integral();
	void regression();
	void launchTTOffset();
	void launchTItoSec();
	void launchT1T2toSec();
	void launchTT1TT2toSec();
	void mergeTS();
	void vect2array();

		

   
protected:

	QAction* checkedProfile;
private:
   
};

