


// >>>> ==== NOTE use conversion factors on page sizes <<<<<<<<<<<<<<
  
     double conv = _conversion_factors[_units_fld->currentItem()];
     double width = string_to_double(_width_fld->text().latin1()) / conv;
     double height=string_to_double(_height_fld->text().latin1())/conv;
	 int xwin_num=string_to_int(_xwin_num_fld->text().latin1());


// =====
cout << " === i_from " << i_from << " i= " << i  << "  ndata = " << ndata << endl;
Time t_dummy_start;
t_dummy_start.set_time_rep(dmin);
cout << t_dummy_start.iso_srep() << " ============ start t" << endl;
t_dummy_start.set_time_rep(dmax);
cout << t_dummy_start.iso_srep() << " ============ end t" << endl;
t_dummy_start.set_time_rep(start[i]);
cout << t_dummy_start.iso_srep() << " ============ start[i]" << endl;
// ====


//--------------------------

bool QpTraceItem::getYRange(double& ymin, double& ymax)
{
	// gets y min and max values for all y values
	 if ( QuSlotDebug() ) printf( " QpTraceItem::getYRange \n" );
		
   	int plotType = I_Type;

	if(plotType == QP_CONST_XT ) return false;

	QdObject_var ydo = QuGetObjByNameAndComp( DataTab->_y_data_fld->text().latin1() );
   
	if(plotType == QP_CONST_Y)
	{
		QdRScalar_var rscalar_var=QdRScalar_var::narrow(ydo);
		if(!rscalar_var.is_nil())
		{
			ymax = rscalar_var->scalar();
			ymin = rscalar_var->scalar();
			return true;
		}
		else
		{
			bool okay=false;
			double d = QString(DataTab->_y_data_fld->text().latin1() ).toDouble(&okay);
			if(okay)
			{
				ymax=d;
				ymin=d;
				return true;
			}
			else return false;
		}
	}
	
	if( ydo.is_nil() ) return false; // can go no further
  
	QpAxisTab *axisTab = I_Panel->yAxisTab;

	int obj_id = ydo->get_id(); 
	// check if y object has changed
	if(axisTab->axis_auto_last == axisTab->_axis_autoscale_fld->currentItem()  && _y_obj_id_getYRange == obj_id)
	{
		// if nothing has changed fetch range calculated last time
		ymin = _y_from;
		ymax = _y_to;
		return true;
	}
  	_y_obj_id_getYRange=obj_id;
	
	// refresh range
	
	bool res = QuGetDataRange(ydo, ymin, ymax);
	
	// store results if min and max found
	if(res)
	{
		_y_from = ymin;
		_y_to = ymax;
	}
	return res;
}

// ---------------------------------------

bool QpPanelItem::getYRange(double& panel_ymin, double& panel_ymax)
{
	// get range of values for y axis
	double ymin = DBL_MAX;
	double ymax =- DBL_MAX;
	QpPlotItem *plotItem = dynamic_cast<QpPlotItem*>(this->firstChild());

	double item_ymin, item_ymax;
	bool empty_range = true;
	while(plotItem)
	{
		QpTraceItem *traceItem = dynamic_cast<QpTraceItem*>(plotItem);
		QpSpectrumItem *SpectrumItem = dynamic_cast<QpSpectrumItem*>(plotItem);
		if(traceItem)
		{
			if(traceItem->getYRange(item_ymin, item_ymax))
			{
				ymin = min(ymin, item_ymin);
				ymax = max(ymax, item_ymax);
				empty_range=false;
			}
		}
		else if(SpectrumItem)
		{
			if(SpectrumItem->getYRange(item_ymin, item_ymax, SpectrumItem->x_min_data, SpectrumItem->x_max_data))
			{
				ymin = min(ymin, item_ymin);
				ymax = max(ymax, item_ymax);
				empty_range = false;
			}
		}
		plotItem = dynamic_cast<QpPlotItem*>(plotItem->nextSibling());
	}
	if(!empty_range)
	{
		panel_ymin = ymin;
		panel_ymax = ymax;
	}
	return !empty_range;
}


// -----------------------------------------------------

bool QpSpectrumItem::getZRange(double& zmin,double& zmax)
{
	// gets z min and max values for all z values
  	if ( QuSlotDebug() ) cout << "QpSpectrumItem::getZRange" << endl;

	zmin = DBL_MAX;
	zmax = -DBL_MAX;
   	
	// fill X will reject if no Z object yet
    _zdo = getZDO();
	if(_zdo.is_nil()) return false;

	if(_zdo->get_id() == zdo_id_getZRange)
	{
		zmin = z_min_data;
		zmax = z_max_data;
		return true;
	}
	zdo_id_getZRange = _zdo->get_id();
	
	
    // reject if no X object yet
    _nx_data = fill_X_Data();
    if ( _nx_data == 0 )   return false;

    _ny_data = fill_Y_Data();  
    if ( _ny_data == -1 ) return false;

    if(_nx_data != _zdo->sequence_size() && _zdo->sequence_size() != 1) return false;
  
    int XtoY = isZConformal(_nx_data, _ny_data);
    if( XtoY == -1)  return false;

    if( fill_Z_Data( XtoY) == -1)  return false;
	
	if (_z_data_all.size() != _nx_data) return false;

	for(int nx=0; nx< _nx_data; nx++){
		if (_z_data_all[nx].size() != _y_start_all[nx].size()) return false;

	    for(int j=0; j< _z_data_all[nx].size(); j++)
		{
			double value_j = (_z_data_all[nx])[j];
			if(value_j == missing_value) continue;
			 
			if( (_y_start_all[nx])[_y_start_all[nx].size() -1] > (_y_start_all[nx])[0] ){
				// increasing
				if(value_j < zmin) zmin = value_j;
				if(value_j > zmax) zmax = value_j;
			}
			else
			{
				// decreasing (start of bin > end of bin) 
				if(value_j < zmin) zmin = value_j;
				if(value_j > zmax) zmax = value_j;
			}
		}
	}
	
	// keep for reuse if nothing changed   
	z_min_data = zmin;
	z_max_data = zmax;
	
	return true;
}

// ----------------------------------

bool QpSpectrumItem::getZYRange(double& zmin, double& zmax, const double ymin, const double ymax)
{
	// gets z min and max values for all z values in range ymin - ymax
	if ( QuSlotDebug() ) cout << "QpSpectrumItem::getZYRange" << endl;

	zmin = DBL_MAX;
	zmax = -DBL_MAX;
		
	bool recalc = false;
	
	// fill X will reject if no Z object yet
    _zdo = getZDO();
	if(_zdo.is_nil()) return false;
  
	if( ColourscaleTab->colour_auto_last != ColourscaleTab->_colourscale_auto_fld->currentItem()  || _zdo->get_id() != zdo_id_getZYRange)
		recalc = true;
		
	zdo_id_getZYRange = _zdo->get_id();
	
    // reject if no X object yet
    _nx_data = fill_X_Data();
    if ( _nx_data == 0 )   return false;
  
  	QpAxisTab * axisTab;
	if(I_Panel->frameType() == QP_TS)  axisTab = I_Panel->I_Frame->tAxisTab;
	else  axisTab = I_Panel->I_Frame->xAxisTab;

	if(axisTab->axis_auto_last != axisTab->_axis_autoscale_fld->currentItem()  || _xdo->get_id() != xdo_id_getZYRange)
		recalc = true;
	
	xdo_id_getZYRange = _xdo->get_id();

    _ny_data = fill_Y_Data();  
    if ( _ny_data == -1 ) return false;
	
	axisTab = I_Panel->yAxisTab;

	if(axisTab->axis_auto_last != axisTab->_axis_autoscale_fld->currentItem()  || _ydo->get_id() != ydo_id_getZYRange)
		recalc = true;
	
	ydo_id_getZYRange = _ydo->get_id();
	
	if(!recalc)
	{
		zmin = z_min_data;
		zmax = z_max_data;
		return true;
	}
	
	
    if(_nx_data != _zdo->sequence_size() && _zdo->sequence_size() != 1) return false;
  
    int XtoY = isZConformal(_nx_data, _ny_data);
    if( XtoY == -1)  return false;

    if( fill_Z_Data( XtoY) == -1)  return false;
	
	if (_z_data_all.size()!= _nx_data) return false;

	for(int nx=0; nx< _nx_data; nx++){
	      if (_z_data_all[nx].size() != _y_start_all[nx].size()) return false;

	      for(int j=0; j< _z_data_all[nx].size(); j++)
		  {
		     double value_j = (_z_data_all[nx])[j];
		  	 if(value_j == missing_value) continue;
			 
             if( (_y_start_all[nx])[_y_start_all[nx].size() -1] > (_y_start_all[nx])[0] ){
                 // increasing
                 if((_y_end_all[nx])[j] < ymin) continue;
	             if((_y_start_all[nx])[j] > ymin) break;
				 
			     if(value_j < zmin) zmin = value_j;
                 if(value_j > zmax) zmax = value_j;
			 }
             else
             {
                 // decreasing (start of bin > end of bin)
                 if((_y_end_all[nx])[j] > ymax) continue;
	             if((_y_start_all[nx])[j] < ymin) break;
				 
			     if(value_j < zmin) zmin = value_j;
                 if(value_j > zmax) zmax = value_j;
			}
		}
	}
	
	// keep for reuse if nothing changed   
	z_min_data = zmin;
	z_max_data = zmax;

	return true;
}

// --------------------------------------

bool QpSpectrumItem::getZXRange(double& zmin, double& zmax, const double xmin, const double xmax)
{
	// gets z min and max values for all z values in range
	// xmin - xmax for the current spectrogram object
 	if ( QuSlotDebug() ) cout << "QpSpectrumItem::getZXRange" << endl;

	zmin = DBL_MAX;
	zmax = -DBL_MAX;
	bool recalc = false;
	
	// fill X will reject if no Z object yet
    _zdo = getZDO();
	if(_zdo.is_nil()) return false;
  
	if( ColourscaleTab->colour_auto_last != ColourscaleTab->_colourscale_auto_fld->currentItem()  || _zdo->get_id() != zdo_id_getZXRange)
		recalc = true;
	
	zdo_id_getZXRange = _zdo->get_id();
 
    // reject if no X object yet
    _nx_data = fill_X_Data();
    if ( _nx_data == 0 )   return false;

  	QpAxisTab * axisTab;
	if(I_Panel->frameType() == QP_TS)  axisTab = I_Panel->I_Frame->tAxisTab;
	else  axisTab = I_Panel->I_Frame->xAxisTab;

	if(axisTab->axis_auto_last != axisTab->_axis_autoscale_fld->currentItem()  || _xdo->get_id() != xdo_id_getZXRange)
		recalc = true;
	
	xdo_id_getZXRange = _xdo->get_id();

	if(!recalc)
	{
		zmin = z_min_data;
		zmax = z_max_data;
		return true;
	}
  	
	int nx_from, nx_to;
	if ( !getBinsForRange( _x_start_all,  _x_end_all,  xmin,  xmax,  nx_from,  nx_to) ) return false;

    _ny_data = fill_Y_Data();  
    if ( _ny_data == -1 ) return false;

    if(_nx_data != _zdo->sequence_size() && _zdo->sequence_size() != 1) return false;
  
    int XtoY = isZConformal(_nx_data, _ny_data);
    if( XtoY == -1)  return false;

    if( fill_Z_Data( XtoY) == -1)  return false;
	
	if (_z_data_all.size() >= nx_to) return false;

	for(int nx=nx_from; nx<=nx_to; nx++){
	      if (_z_data_all[nx].size() != _y_start_all[nx].size()) return false;

	      for(int j=0; j< _z_data_all[nx].size(); j++)
		  {
		     double value_j = (_z_data_all[nx])[j];
		  	 if(value_j == missing_value) continue;
			 
             if( (_y_start_all[nx])[_y_start_all[nx].size() -1] > (_y_start_all[nx])[0] ){
                 // increasing
				 if(value_j < zmin) zmin = value_j;
                 if(value_j > zmax) zmax = value_j;
			 }
             else
			{
				// decreasing (start of bin > end of bin)
				if(value_j < zmin) zmin = value_j;
				if(value_j > zmax) zmax = value_j;
			}
		}
	}
	   	
	// keep for reuse if nothing changed   
	z_min_data = zmin;
	z_max_data = zmax;

	return true;

}

// ------------------------------------

bool QpSpectrumItem::getYRange(double& ymin, double& ymax)
{
	// gets y min and max values for whole Y axis
	if ( QuSlotDebug() ) cout << "QpSpectrumItem::getYRange" << endl;

	ymin=DBL_MAX;
	ymax=-DBL_MAX;
  
	_zdo = getZDO();
	if(_zdo.is_nil()) return false;

	// reject if no X object yet (also traps no z object)
	_nx_data = fill_X_Data();
	if ( _nx_data == 0 )   return false;
  
	_ny_data = fill_Y_Data();  
	if ( _ny_data == -1 ) return false;

	QpAxisTab * axisTab = I_Panel->yAxisTab;
	if(axisTab->axis_auto_last == axisTab->_axis_autoscale_fld->currentItem()  && _ydo->get_id() == ydo_id_getYRange)
	{		
		ymin = y_min_data;
		ymax = y_max_data;
		return true;
	}
	
	for(int i=0; i< _nx_data; i++)
	{
		// find ymin and ymax for each x bin
		// assume monotonic axis, but min may be larger than max if decreasing
		if( (_y_start_all[i])[_y_start_all[i].size() -1] > (_y_start_all[i])[0] ){
			// increasing
			double ymini = (_y_start_all[i])[0];
			double ymaxi = (_y_end_all[i])[_y_end_all[i].size() -1];
			if(ymax < ymaxi) ymax = ymaxi;
			if(ymin > ymini) ymin = ymini;
		}
		else
		{
			// decreasing, taking care of deltas being either sign
			double ymini = (_y_start_all[i])[_y_start_all[i].size() -1];
			double ymini_2 = (_y_end_all[i])[_y_end_all[i].size() -1];
			double ymaxi = (_y_end_all[i])[0];
			double ymaxi_2 = (_y_start_all[i])[0];
			if(ymax < ymaxi) ymax = ymaxi;
			if(ymax < ymaxi_2) ymax = ymaxi_2;
			if(ymin > ymini) ymin = ymini;
			if(ymin > ymini_2) ymin = ymini_2;
		}
	}
	
	// store to reuse if nothing changed
	y_min_data = ymin;
	y_max_data = ymax;	

	return true;
}



from qpui_window.cc
------------------

  // create Page Options widget
  _page_options=new QpuiPageOptions(plot_groupbox);
  connect(_page_options,SIGNAL(deviceChanged(QpuiListViewItem*)),_plot_listview,\
    SLOT(resetPlotId(QpuiListViewItem*)));
  connect(_page_options,SIGNAL(layoutChanged(QpuiListViewItem*)),_plot_listview,\
    SIGNAL(pageLayoutChanged(QpuiListViewItem*)));
  connect(_plot_listview,SIGNAL(showPageOptions(QpuiListViewItem*)),
    this,SLOT(showPageOptions(QpuiListViewItem*)));
  connect(_page_options,SIGNAL(pageChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(setPlotOptions(QpuiPlotOptions*)));
  connect(_plot_listview,SIGNAL(showValueReturnPB(bool)),_page_options,
    SLOT(showValueReturnPB(bool)));
  connect(_plot_listview,SIGNAL(raiseWindow()),this,SLOT(bringToFront()));

  // create Panel Options widget
  _panel_options=new QpuiPanelOptions(plot_groupbox,"panel",false,false,false);
  connect(_plot_listview,SIGNAL(showPanelOptions(QpuiListViewItem*)),
    this,SLOT(showPanelOptions(QpuiListViewItem*)));
  connect(_panel_options,SIGNAL(panelChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(setPlotOptions(QpuiPlotOptions*)));
  _panel_options->hide();

  // create Time Series Trace Panel Options widget
  _typanel_options=new QpuiPanelOptions(plot_groupbox,"typanel",false,true,true);
  connect(_plot_listview,SIGNAL(showTYPanelOptions(QpuiListViewItem*)),
    this,SLOT(showTYPanelOptions(QpuiListViewItem*)));
  connect(_typanel_options,SIGNAL(panelChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(setPlotOptions(QpuiPlotOptions*)));
  _typanel_options->hide();

  // create Time Series Stack Panel Options widget
  _tspanel_options=new QpuiPanelOptions(plot_groupbox,"tspanel",false,false,true);
  connect(_plot_listview,SIGNAL(showTSPanelOptions(QpuiListViewItem*)),
    this,SLOT(showTSPanelOptions(QpuiListViewItem*)));
  connect(_tspanel_options,SIGNAL(panelChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(setPlotOptions(QpuiPlotOptions*)));
  _tspanel_options->hide();

  // create XY Stack Panel Options widget
  _xspanel_options=new QpuiPanelOptions(plot_groupbox,"xspanel",
    true,false,false);
  connect(_plot_listview,SIGNAL(showXSPanelOptions(QpuiListViewItem*)),
    this,SLOT(showXSPanelOptions(QpuiListViewItem*)));
  connect(_xspanel_options,SIGNAL(panelChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(setPlotOptions(QpuiPlotOptions*)));
  _xspanel_options->hide();

  // create XY Trace Panel Options widget
  _xypanel_options=new QpuiPanelOptions(plot_groupbox,"xypanel",
    true,true,false);
  connect(_plot_listview,SIGNAL(showXYPanelOptions(QpuiListViewItem*)),
    this,SLOT(showXYPanelOptions(QpuiListViewItem*)));
  connect(_xypanel_options,SIGNAL(panelChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(setPlotOptions(QpuiPlotOptions*)));
  _xypanel_options->hide();

  // create Trace Options widget
  _trace_options=new QpuiTraceOptions(plot_groupbox);
  connect(_plot_listview,SIGNAL(showTraceOptions(QpuiListViewItem*)),
    this,SLOT(showTraceOptions(QpuiListViewItem*)));
  connect(_trace_options,SIGNAL(traceChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(setPlotOptions(QpuiPlotOptions*)));
  connect(_trace_options,SIGNAL(plotTypeChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(setPlotType(QpuiPlotOptions*)));
  connect(_trace_options,SIGNAL(status_msg(const QString&)),this,\
    SLOT(status(const QString&)));
  connect(_trace_options,SIGNAL(yAxisChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(yAxisChanged(QpuiPlotOptions*)));
  connect(_trace_options,SIGNAL(xAxisChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(xAxisChanged(QpuiPlotOptions*)));
  _trace_options->hide();

  // create Event Options widget
  _event_options=new QpuiEventOptions(plot_groupbox);
  connect(_plot_listview,SIGNAL(showEventOptions(QpuiListViewItem*)),
    this,SLOT(showEventOptions(QpuiListViewItem*)));
  connect(_event_options,SIGNAL(eventChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(setPlotOptions(QpuiPlotOptions*)));
  _event_options->hide();
  
  // create Stack Options widget
  _stack_options=new QpuiStackOptions(plot_groupbox);
  connect(_plot_listview,SIGNAL(showStackOptions(QpuiListViewItem*)),
    this,SLOT(showStackOptions(QpuiListViewItem*)));
  connect(_stack_options,SIGNAL(stackChanged(QpuiPlotOptions*)),
    _plot_listview,SLOT(setPlotOptions(QpuiPlotOptions*)));
  _stack_options->hide();

  // create Spectrogram Options widget
  _spectrogram_options=new QpuiSpectroGramOptions(plot_groupbox);
  connect(_plot_listview,SIGNAL(showSpectroGramOptions(QpuiListViewItem*)), this,SLOT(showSpectroGramOptions(QpuiListViewItem*)));
  connect(_spectrogram_options,SIGNAL(spectrogramChanged(QpuiPlotOptions*)),  _plot_listview,SLOT(setPlotOptions(QpuiPlotOptions*)));
  connect(_spectrogram_options,SIGNAL(plotTypeChanged(QpuiPlotOptions*)), _plot_listview,SLOT(setPlotType(QpuiPlotOptions*)));
  connect(_spectrogram_options,SIGNAL(status_msg(const QString&)),this,  SLOT(status(const QString&)));
  connect(_spectrogram_options,SIGNAL(yAxisChanged(QpuiPlotOptions*)), _plot_listview,SLOT(yAxisChanged(QpuiPlotOptions*)));
  connect(_spectrogram_options,SIGNAL(xAxisChanged(QpuiPlotOptions*)), _plot_listview,SLOT(xAxisChanged(QpuiPlotOptions*)));
  _spectrogram_options->hide();

void QpWindow::showEventOptions(QpuiListViewItem* item)
{
   // slot called when signal emitted from plot listview
   // shows event options for item

   if( QuSlotDebug() ) cout << "QpuiWindow::showEventOptions" << endl;
  
   if(_plot_options!=_event_options)
   {
     if(_plot_options!=NULL)
     {
       _plot_options->hide();
       _plot_options->_plot_item=0;
       for(int i=0;i<_plot_options->_sub_options.size();i++)
       {
          if(_plot_options->_sub_options[i])
	    _plot_options->_sub_options[i]->_plot_item=0;
       }
     }
     _plot_options=_event_options;
   }
   if(_event_options)
   {
     _event_options->_plot_item=0;
     for(int i=0;i<_event_options->_sub_options.size();i++)
     {
        if(_event_options->_sub_options[i])
	  _event_options->_sub_options[i]->_plot_item=0;
     }
     _event_options->show();
     _event_options->getOptions(item);
   }
}


void QpuiWindow::showPanelOptions(QpuiListViewItem* item)
{
   // slot called when signal emitted from plot listview
   // shows time series trace panel options for item

   if( QuSlotDebug() ) cout << "QpuiWindow::showPanelOptions" << endl;
  
   if(_plot_options!=_panel_options)
   {
     if(_plot_options!=NULL)
     {
       _plot_options->hide();
       _plot_options->_plot_item=0;
       for(int i=0;i<_plot_options->_sub_options.size();i++)
       {
          if(_plot_options->_sub_options[i])
	    _plot_options->_sub_options[i]->_plot_item=0;
       }
     }
     _plot_options=_panel_options;
   }
   if(_panel_options)
   {
     _panel_options->_plot_item=0;
     for(int i=0;i<_panel_options->_sub_options.size();i++)
     {
        if(_panel_options->_sub_options[i])
	  _panel_options->_sub_options[i]->_plot_item=0;
     }
     _panel_options->show();
     _panel_options->getOptions(item);
   }

}

void QpuiWindow::showPageOptions(QpuiListViewItem* item)
{
   // slot called when signal emitted from plot listview
   // shows page options for item
   if( QuSlotDebug() ) cout << "QpuiWindow::showPageOptions" << endl;

   if(_plot_options!=_page_options)
   {
     if(_plot_options!=NULL)
     {
       _plot_options->hide();
       _plot_options->_plot_item=0;
       for(int i=0;i<_plot_options->_sub_options.size();i++)
       {
          if(_plot_options->_sub_options[i])
	    _plot_options->_sub_options[i]->_plot_item=0;
       }
     }
     _plot_options=_page_options;
   }
   if(_page_options)
   {
     _page_options->_plot_item=0;
     for(int i=0;i<_page_options->_sub_options.size();i++)
     {
        if(_page_options->_sub_options[i])
	  _page_options->_sub_options[i]->_plot_item=0;
     }
     _page_options->show();
     _page_options->getOptions(item);
   }
 }

void QpuiWindow::showSpectroGramOptions(QpuiListViewItem* item)
{
   // slot called when signal emitted from plot listview
   // shows spectrogram options for item
   if( QuSlotDebug() ) cout << "QpuiWindow::showSpectroGramOptions" << endl;

   if(_plot_options!=_spectrogram_options)
   {
     if(_plot_options!=NULL)
     {
       _plot_options->hide();
       _plot_options->_plot_item=0;
       for(int i=0;i<_plot_options->_sub_options.size();i++)
       {
          if(_plot_options->_sub_options[i])
	    _plot_options->_sub_options[i]->_plot_item=0;
       }
     }
     _plot_options=_spectrogram_options;
   }
   if(_spectrogram_options)
   {
     _spectrogram_options->_plot_item=0;
     for(int i=0;i<_spectrogram_options->_sub_options.size();i++)
     {
        if(_spectrogram_options->_sub_options[i])
	  _spectrogram_options->_sub_options[i]->_plot_item=0;
     }
     _spectrogram_options->show();
     _spectrogram_options->getOptions(item);
   }
}

void QpuiWindow::showStackOptions(QpuiListViewItem* item)
{
   // slot called when signal emitted from plot listview
   // shows stack sub-panel options for item
   if( QuSlotDebug() ) cout << "QpuiWindow::showStackOptions" << endl;

   if(_plot_options!=_stack_options)
   {
     if(_plot_options!=NULL)
     {
       _plot_options->hide();
       _plot_options->_plot_item=0;
       for(int i=0;i<_plot_options->_sub_options.size();i++)
       {
          if(_plot_options->_sub_options[i])
	    _plot_options->_sub_options[i]->_plot_item=0;
       }
     }
     _plot_options=_stack_options;
   }
   if(_stack_options)
   {
     _stack_options->_plot_item=0;
     for(int i=0;i<_stack_options->_sub_options.size();i++)
     {
        if(_stack_options->_sub_options[i])
	  _stack_options->_sub_options[i]->_plot_item=0;
     }
     _stack_options->show();
     _stack_options->getOptions(item);
   }
}

void QpuiWindow::showTraceOptions(QpuiListViewItem* item)
{
   // slot called when signal emitted from plot listview
   // shows trace options for item
   if( QuSlotDebug() ) cout << "QpuiWindow::showTraceOptions" << endl;

   if(_plot_options!=_trace_options)
   {
     if(_plot_options!=NULL)
     {
       _plot_options->hide();
       _plot_options->_plot_item=0;
       for(int i=0;i<_plot_options->_sub_options.size();i++)
       {
          if(_plot_options->_sub_options[i])
	    _plot_options->_sub_options[i]->_plot_item=0;
       }
     }
     _plot_options=_trace_options;
   }
   if(_trace_options)
   {
     _trace_options->_plot_item=0;
     for(int i=0;i<_trace_options->_sub_options.size();i++)
     {
        if(_trace_options->_sub_options[i])
	  _trace_options->_sub_options[i]->_plot_item=0;
     }
     _trace_options->show();
     _trace_options->getOptions(item);
   }
}

void QpuiWindow::showTSPanelOptions(QpuiListViewItem* item)
{
   // slot called when signal emitted from plot listview
   // shows time series stack sub-panel options for item
   if( QuSlotDebug() ) cout << "QpuiWindow::showTSPanelOptions" << endl;

   if(_plot_options!=_tspanel_options)
   {
     if(_plot_options!=NULL)
     {
       _plot_options->hide();
       _plot_options->_plot_item=0;
       for(int i=0;i<_plot_options->_sub_options.size();i++)
       {
          if(_plot_options->_sub_options[i])
	    _plot_options->_sub_options[i]->_plot_item=0;
       }
     }
     _plot_options=_tspanel_options;
   }
   if(_tspanel_options)
   {
     _tspanel_options->_plot_item=0;
     for(int i=0;i<_tspanel_options->_sub_options.size();i++)
     {
        if(_tspanel_options->_sub_options[i])
	 _tspanel_options->_sub_options[i]->_plot_item=0;
     }
     _tspanel_options->show();
     _tspanel_options->getOptions(item);
   }

}

void QpuiWindow::showTYPanelOptions(QpuiListViewItem* item)
{
   // slot called when signal emitted from plot listview
   // shows time series trace panel options for item
   if( QuSlotDebug() ) cout << "QpuiWindow::showTYPanelOptions" << endl;

   if(_plot_options!=_typanel_options)
   {
     if(_plot_options!=NULL)
     {
       _plot_options->hide();
       _plot_options->_plot_item=0;
       for(int i=0;i<_plot_options->_sub_options.size();i++)
       {
          if(_plot_options->_sub_options[i])
	    _plot_options->_sub_options[i]->_plot_item=0;
       }
     }
     _plot_options=_typanel_options;
   }
   if(_typanel_options)
   {
     _typanel_options->_plot_item=0;
     for(int i=0;i<_typanel_options->_sub_options.size();i++)
     {
        if(_typanel_options->_sub_options[i])
	 _typanel_options->_sub_options[i]->_plot_item=0;
     }
     _typanel_options->show();
     _typanel_options->getOptions(item);
   }

}

void QpuiWindow::showXSPanelOptions(QpuiListViewItem* item)
{
   // slot called when signal emitted from plot listview
   // shows xy stack sub-panel options for item
   if( QuSlotDebug() ) cout << "QpuiWindow::showXSPanelOptions" << endl;

   if(_plot_options!=_xspanel_options)
   {
     if(_plot_options!=NULL)
     {
       _plot_options->hide();
       _plot_options->_plot_item=0;
       for(int i=0;i<_plot_options->_sub_options.size();i++)
       {
          if(_plot_options->_sub_options[i])
	    _plot_options->_sub_options[i]->_plot_item=0;
       }

     }
     _plot_options=_xspanel_options;
   }
   if(_xspanel_options)
   {
     _xspanel_options->_plot_item=0;
     for(int i=0;i<_xspanel_options->_sub_options.size();i++)
     {
        if(_xspanel_options->_sub_options[i])
	 _xspanel_options->_sub_options[i]->_plot_item=0;
     }
     _xspanel_options->show();
     _xspanel_options->getOptions(item);
   }
}

void QpuiWindow::showXYPanelOptions(QpuiListViewItem* item)
{
   // slot called when signal emitted from plot listview
   // shows xy trace panel options for item
   if( QuSlotDebug() ) cout << "QpuiWindow::showXYPanelOptions" << endl;

   if(_plot_options!=_xypanel_options)
   {
     if(_plot_options!=NULL)
     {
       _plot_options->hide();
       _plot_options->_plot_item=0;
       for(int i=0;i<_plot_options->_sub_options.size();i++)
       {
          if(_plot_options->_sub_options[i])
	    _plot_options->_sub_options[i]->_plot_item=0;
       }

     }
     _plot_options=_xypanel_options;
   }
   if(_xypanel_options)
   {
     _xypanel_options->_plot_item=0;
     for(int i=0;i<_xypanel_options->_sub_options.size();i++)
     {
        if(_xypanel_options->_sub_options[i])
	 _xypanel_options->_sub_options[i]->_plot_item=0;
     }
     _xypanel_options->show();
     _xypanel_options->getOptions(item);
   }
}


//-----------------------------------------------
// from Listview

	 if( isTS != toTS){
	    // create new Frame and Panel as type incompatible with this Frame
		// will be inserted after _frame as it is incompatible type to current frame
		
		QpListItem * newItem = createPlotItem(_frame, plotType, item->QpDataTab->_y_data_fld->text().latin1());
		AddToSelectedList(newItem);

		RemoveFromSelectedList(item);
        delete item;
		if (_panel->firstChild() == 0) 
		{
		  // Panel is now empty delete it
		  
		  RemoveFromSelectedList(_panel);
		  delete _panel;
		  if (_frame->firstChild() == 0) 
		  {
		     // Frame now empty delete it
		     RemoveFromSelectedList(_frame);
		     delete _frame;
		  }
		}
	 }
	 if( isTS != toTS){
	    // create new Frame and Panel as type incompatible with this Frame
		// will be inserted after _frame as it is incompatible type		
		
		QpListItem * newItem = createPlotItem(_frame, plotType, item->QpSpectrumDataTab->_z_data_fld->text().latin1());
		AddToSelectedList(newItem);

		RemoveFromSelectedList(item);
        delete item;
		if (_panel->firstChild() == 0) 
		{
		  // Panel is now empty delete it
		  
		  RemoveFromSelectedList(_panel);
		  delete _panel;
		  if (_frame->firstChild() == 0) 
		  {
		     // Frame now empty delete it
		     RemoveFromSelectedList(_frame);
		     delete _frame;
		  }
		}
	 }

  // find common root of selected items
  QpuiListViewItem *root=
    dynamic_cast<QpuiListViewItem*>(findCommonRoot());
  if(!root)
  {
    // removed obsolete code ensuring selectedList is in plot
    (void)QMessageBox::warning(this,msg_title.c_str(),
      "Confusing selection");
    return;
  }
  if(localList.size()==0)
  {
    (void)QMessageBox::warning(this,msg_title.c_str(),"No items selected");
    return;
  }
  pageItem=dynamic_cast<QpuiPageListViewItem*>(root);
  tspanelItem=dynamic_cast<QpuiTSPanelListViewItem*>(root);
  xypanelItem=dynamic_cast<QpuiXYPanelListViewItem*>(root);
  xystackItem=dynamic_cast<QpuiXYStackListViewItem*>(root);
  xytraceItem=dynamic_cast<QpuiXYTraceListViewItem*>(root);
  tsstackItem=dynamic_cast<QpuiTSStackListViewItem*>(root);
  tstraceItem=dynamic_cast<QpuiTSTraceListViewItem*>(root);
  constttraceItem=dynamic_cast<QpuiConstTTraceListViewItem*>(root);
  constxtraceItem=dynamic_cast<QpuiConstXTraceListViewItem*>(root);
  constytraceItem=dynamic_cast<QpuiConstYTraceListViewItem*>(root);
  spectrogramItem=dynamic_cast<QpuiTSSpectroGramListViewItem*>(root);
  xyspectrogramItem=dynamic_cast<QpuiXYSpectroGramListViewItem*>(root);
  tseventItem=dynamic_cast<QpuiTSEventListViewItem*>(root);
  xyeventItem=dynamic_cast<QpuiXYEventListViewItem*>(root);