// qpui_spectrogram_options.cc
//
// Plot Interface Implementation - Spectrogram Options
//
// Janet Barnes
// July 2002
//
// Tony Allen
// Feb 2008

#include "qpui.h"
#include "qdutil.h"

#include <qtooltip.h>
#include <QGroupBox>



// Data Tab for Spectrogram
// -------------------------
/*
void QpDataTab::setXEndData()
{
	// slot called when x data name field changed on widget
	
	if( QuSlotDebug() ) cout << "Spectrum QpDataTab::setXEndData = " << _x_end_data_fld->text().toLatin1().data() << endl;

	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	if( !I_Spectrum) return;
	
	QString x_data = _x_end_data_fld->text();

	QdObject_var xdo = _x_end_data_fld->getSlotObject();

	if(xdo.is_nil())
	{
		I_Spectrum->_x_end_obj_id=0;
		return;
	}

	// only tell list view to make changes to selected spectrum items if this
	// is the tab being user modified (avoids infinite loop from signals as hidden tabs change)
      	
	QString BaseName = baseObjectText(x_data); // new value
	QString oldBaseName = baseObjectText(I_Spectrum->x_data_end_str); // old value
	QString sChoice;
	if(BaseName != oldBaseName) sChoice = BaseName.toLatin1().data();
	else sChoice = QString(x_data.toLatin1().data()).remove(BaseName);
	
	// keep for comparison when changed
	I_Spectrum->x_data_end_str = x_data.toLatin1().data(); // used only for comparison when changed

 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_XDATA_END, 0, 0.0, sChoice);

	return;
 }
*/
void QpDataTab::setXStartData()
{
	// slot called when x start data name field changed on widget
	
	if( QuSlotDebug() ) cout << "Spectrum QpDataTab::setXStartData = " << _x_start_data_fld->text().toLatin1().data() << endl;

	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	if( !I_Spectrum) return;
	
	QString x_data = _x_start_data_fld->text();

	QdObject_var xdo = _x_start_data_fld->getSlotObject();

	if(xdo.is_nil())
	{
		I_Spectrum->_x_start_obj_id = 0;
	//	_x_end_data_fld->setEnabled(false);
		if (_y_start_data_fld->text() == "") _XYtoggle->setEnabled(true);
		return;
	}

//	_x_end_data_fld->setEnabled(true);
	_XYtoggle->setEnabled(false);
	_XYtoggle->setChecked(false);
	
	// update axes
	I_Spectrum->updateAxes();

	
	// only tell list view to make changes to selected spectrum items if this
	// is the tab being user modified (avoids infinite loop from signals as hidden tabs change)
   	
	QString BaseName = baseObjectText(x_data); // new value
	QString oldBaseName = baseObjectText(I_Spectrum->x_data_start_str); // old value
	QString sChoice;
	if(BaseName != oldBaseName) sChoice = BaseName.toLatin1().data();
	else sChoice = QString(x_data.toLatin1().data()).remove(BaseName);
	
	// keep for comparison when changed
	I_Spectrum->x_data_start_str = x_data.toLatin1().data(); // used only for comparison when changed

 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_XDATA_START, 0, 0.0, sChoice);

	return;
}
/*
void QpDataTab::setYEndData()
{
	// slot called when y data name field changed on widget
	
	if( QuSlotDebug() ) cout << "Spectrum QpDataTab::setYEndData = " << _y_end_data_fld->text().toLatin1().data() << endl;

	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	if( !I_Spectrum) return;

	QString y_data = _y_end_data_fld->text();
	
	QdObject_var ydo = _y_end_data_fld->getSlotObject();

	if(ydo.is_nil())
	{
		I_Spectrum->_y_end_obj_id = 0;
		return;
	}
	
	// only tell list view to make changes to selected spectrum items if this
	// is the tab being user modified (avoids infinite loop from signals as hidden tabs change)
      	
	QString BaseName = baseObjectText(y_data); // new value
	QString oldBaseName = baseObjectText(I_Spectrum->y_data_end_str); // old value
	QString sChoice;
	if(BaseName != oldBaseName) sChoice = BaseName.toLatin1().data();
	else sChoice = QString(y_data.toLatin1().data()).remove(BaseName);
	
	// keep for comparison when changed
	I_Spectrum->y_data_end_str = y_data.toLatin1().data(); // used only for comparison when changed

 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_YDATA_END, 0, 0.0, sChoice);

	return;
}
*/
void QpDataTab::checkYStartData(const QString & txt)
{
	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	if( !I_Spectrum) return;
	
	if(txt.isEmpty()){
		// reset y data as object deleted
		setYStartData();
		// tell Z slot to modify ranges
		I_Spectrum->updateAxes();

	}
}

void QpDataTab::setYStartData()
{
	// slot called when y data name field changed on widget
	
	if( QuSlotDebug() ) cout << "Spectrum QpDataTab::setYStartData = " << _y_start_data_fld->text().toLatin1().data() << endl;

	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	if( !I_Spectrum) return;

	QString y_data = _y_start_data_fld->text();
	
	QdObject_var ydo = _y_start_data_fld->getSlotObject();
	if(ydo.is_nil() ) 
	{
		I_Spectrum->_y_start_obj_id=0;
//		_y_end_data_fld->setEnabled(false);
		if (_x_start_data_fld->text() == "") _XYtoggle->setEnabled(true);
		return;
	}

//	_y_end_data_fld->setEnabled(true);
	_XYtoggle->setEnabled(false);
	_XYtoggle->setChecked(false);

	// tell Z slot to modify ranges
	I_Spectrum->updateAxes();
	
	// only tell list view to make changes to selected spectrum items if this
	// is the tab being user modified (avoids infinite loop from signals as hidden tabs change)
   	
	QString BaseName = baseObjectText(y_data); // new value
	QString oldBaseName = baseObjectText(I_Spectrum->y_data_start_str); // old value
	QString sChoice;
	if(BaseName != oldBaseName) sChoice = BaseName.toLatin1().data();
	else sChoice = QString(y_data.toLatin1().data()).remove(BaseName);
	
	// keep for comparison when changed
	I_Spectrum->y_data_start_str = y_data.toLatin1().data(); // used only for comparison when changed

 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_YDATA_START, 0, 0.0, sChoice);

	return;
}

void QpDataTab::setXYswap()
{
	if( QuSlotDebug() ) cout << "Spectrum QpDataTab::setXYswap " <<  endl;
	
	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	if( !I_Spectrum) return;
	
	// set axes to default to ensure ranges try to reset sensibly
	int xLinlog = I_Spectrum->frame()->xAxisTab->_axis_linlog_fld->currentIndex();
	int yLinlog = I_Spectrum->panel()->yAxisTab->_axis_linlog_fld->currentIndex();
	I_Spectrum->frame()->xAxisTab->_axis_linlog_fld->setCurrentIndex(yLinlog);
	I_Spectrum->panel()->yAxisTab->_axis_linlog_fld->setCurrentIndex(xLinlog);

	double x_from(I_Spectrum->frame()->xAxisTab->_axis_xy_fld->getStart());
	double x_to(I_Spectrum->frame()->xAxisTab->_axis_xy_fld->getEnd());
	double y_from(I_Spectrum->panel()->yAxisTab->_axis_xy_fld->getStart());
	double y_to(I_Spectrum->panel()->yAxisTab->_axis_xy_fld->getEnd()); 
	 
	I_Spectrum->frame()->xAxisTab->_axis_xy_fld->setInterval(y_from, y_to);
	I_Spectrum->frame()->xAxisTab->_axis_autoscale_fld->setCurrentIndex(QP_FROM_META);
	I_Spectrum->panel()->yAxisTab->_axis_xy_fld->setInterval(x_from, x_to);
	I_Spectrum->panel()->yAxisTab->handleAutoScale(QP_FROM_META);
	
	// swap tick choices
	int xMajTick = I_Spectrum->frame()->xAxisTab->_axis_major_tickmarks_fld->currentIndex();
	int xMinTick = I_Spectrum->frame()->xAxisTab->_axis_minor_tickmarks_fld->currentIndex();
	
	int yMajTick = I_Spectrum->panel()->yAxisTab->_axis_major_tickmarks_fld->currentIndex();
	int yMinTick = I_Spectrum->panel()->yAxisTab->_axis_minor_tickmarks_fld->currentIndex();
	
	I_Spectrum->frame()->xAxisTab->_axis_major_tickmarks_fld->setCurrentIndex(yMajTick);
	I_Spectrum->frame()->xAxisTab->_axis_minor_tickmarks_fld->setCurrentIndex(yMinTick);

	I_Spectrum->panel()->yAxisTab->_axis_major_tickmarks_fld->setCurrentIndex(xMajTick);
	I_Spectrum->panel()->yAxisTab->_axis_minor_tickmarks_fld->setCurrentIndex(xMinTick);
	
	// swap num ticks
	int xMajTickNum = I_Spectrum->frame()->xAxisTab->_axis_major_ticks_num_fld->value();
	int xMinTickNum = I_Spectrum->frame()->xAxisTab->_axis_minor_ticks_num_fld->value();
	
	int yMajTickNum = I_Spectrum->panel()->yAxisTab->_axis_major_ticks_num_fld->value();
	int yMinTickNum = I_Spectrum->panel()->yAxisTab->_axis_minor_ticks_num_fld->value();
	
	I_Spectrum->frame()->xAxisTab->_axis_major_ticks_num_fld->setValue(yMajTickNum);
	I_Spectrum->frame()->xAxisTab->_axis_minor_ticks_num_fld->setValue(yMinTickNum);

	I_Spectrum->panel()->yAxisTab->_axis_major_ticks_num_fld->setValue(xMajTickNum);
	I_Spectrum->panel()->yAxisTab->_axis_minor_ticks_num_fld->setValue(xMinTickNum);
	
	
	// X and Y axes swapped on spectrum, force axis update to refill x, y and z data
	I_Spectrum->xdo_id_getXRange = 0;
	I_Spectrum->ydo_id_getYRange = 0;
	I_Spectrum->_z_obj_id = 0;
	setZData();
	
	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_XY_SWAP, 0);

}

void QpDataTab::setZData()
{
	// slot called when z data name field changed on widget
	// or Colourscale tab brought to front

	if( QuSlotDebug() ) cout << "Spectrum QpDataTab::setZData = '" << _z_data_fld->text().toLatin1().data() << "'" << endl;

	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	if( !I_Spectrum) return;
	
	I_Spectrum->updateAxes();


	// is change to base object or component...
	QString BaseName = baseObjectText(_z_data_fld->text()); // new value
	QString CompText = compText( _z_data_fld->text() ); // new value

	bool compOnly = false;
	if(old_BaseName == BaseName ) compOnly = true;
	old_BaseName = QString(BaseName.toLatin1().data());

	// if item uses data name change it
	if( /*!(I_Spectrum->nameLock) &&*/ !(_z_data_fld->text().isEmpty())) {
		I_Spectrum->setName(_z_data_fld->text());
	}
	I_Spectrum->WLcontext = BaseName.toLatin1().data();
	

	// only tell list view to make changes to selected spectrum items if this
	// is the tab being user modified (avoids infinite loop from signals as hidden tabs change)

	if(this->isVisible() ) {
		// propagate to selected items 
 		if(compOnly) I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_ZCOMP, 0, 0.0, CompText);
 		else I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_ZDATA, 0, 0.0, BaseName);
	}
	
	// propagate to linked spectra, component selection is NOT propagated to linked items
	if(!(I_Spectrum->root()->I_PlotView->isLink))
	{
		bool discard = false; // used to find onceOnly linkage
		I_Spectrum->root()->I_PlotView->isLink = true; // stops infinite recursion;
		foreach(PlotItem* item, I_Spectrum->linkedPlots)
		{
			if(item==I_Spectrum) continue;
			if(!compOnly) item->replaceData(BaseName);
			if(item->getLinkText().contains("**"))
			{
				//once only linkage
				item->setLinkText("");
				discard=true;
			}
		}
		if(discard) 
		{
			I_Spectrum->setLinkText("");
			I_Spectrum->linkedPlots.clear();
		}
		I_Spectrum->root()->I_PlotView->isLink = false;
	}
	
//	updateGapThreshold(); // does nothing for spectra ?
	return;
}

void QpDataTab::setTI_ZData()
{
	if( QuSlotDebug() ) cout << " QpDataTab::setTI_ZData  " << endl;
	// slot called when y data name field changed on widget

	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	if( !I_Spectrum) return;	
	
	// is change to base object or component...
	QString BaseName = baseObjectText( _mask_data_fld->text() ); // new value
	QString CompText = compText( _mask_data_fld->text() ); // new value
	bool compOnly = false;
	if(old_BaseTIName == BaseName ) compOnly = true;
	old_BaseTIName = QString(BaseName.toLatin1().data());

	if(this->isVisible() ) {
		// propagate to selected items 

	
		if(compOnly) I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_TICOMP, 0, 0.0, CompText);
		else  I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_TIDATA, 0, 0.0, BaseName);
	}

	I_Spectrum->updateAxes(); // also sets _ydo
}

void QpDataTab::gap_toggle_changed(bool on)
{
	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	I_Spectrum->refreshX();

	// only visible tab propagates
	if(this->isVisible())
	{	
		I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_GAP, 0, 0.0, "", on);
	}
}

void QpDataTab::interlace_toggle_changed(bool on)
{
	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	if(I_Spectrum) I_Spectrum->refreshX();

	if(on) minCellWidth->setEnabled(false);
	else minCellWidth->setEnabled(true);
	
	// only visible tab propagates
	if(this->isVisible())
	{	
		I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_INTERLACE, 0, 0.0, "", on);
	}
}

void QpDataTab::minCellWidth_changed(double value)
{
	SpectrumItem *I_Spectrum = dynamic_cast<SpectrumItem*>(I_Plot);
	
	// only visible tab propagates
	if(this->isVisible() && I_Spectrum)
	{	
		I_Spectrum->root()->I_PlotView->setSpectrumOption(SPECTROGRAM_MIN_CELL_WIDTH, 0, value);
	}
}



// ColourScale Tab
// -------------------

// -------------------------------------------

QpColourscaleTab::QpColourscaleTab(QTabWidget *tabWidget,  const QString& name, SpectrumItem * _spectro):
		QpTab(tabWidget, name, QP_COLOUR_TAB)
{
	// Constructor for the Colour Scale Tab widget shown in the SpectroGram Options

	I_Spectrum = _spectro;
	
	create();

	connect( _colourscale_auto_fld, SIGNAL(activated(int)), this, SLOT(setAutoScale(int)) );
	connect( _colourscale_linlog_fld, SIGNAL(activated(int)), this, SLOT(setLinLog(int)) );
	connect( _colourscale_min_fld, SIGNAL(edited_OK()), this, SLOT(setColourScaleMin()) );
	connect( _colourscale_max_fld, SIGNAL(edited_OK()), this, SLOT(setColourScaleMax()) );
	connect( _colourscale_show_colour_bar_fld, SIGNAL(toggled(bool)), this, SLOT(setShowColourBar(bool)) );
	connect(_colourscale_colour_bar_width_fld, SIGNAL(valueChanged(double)), this, SLOT(setColourbarWidth(double)));
	connect(_colourscale_colour_bar_height_fld, SIGNAL(valueChanged(double)), this, SLOT(setColourbarHeight(double)));
	connect(_colourscale_colour_bar_voffset_fld, SIGNAL(valueChanged(double)), this, SLOT(setColourbarVoffset(double)));
// 	connect( _colourscale_table_fld, SIGNAL(activated(int)), this, SLOT(setColourtable(int)) );
    connect(_colourtable_fld, SIGNAL(selectedStd(int)), this, SLOT(setColourtableStd(int)));
    connect(_colourtable_fld, SIGNAL(selectedProfile(int)), this, SLOT(setColourtableProfile(int)));
    connect(_colourtable_fld, SIGNAL(selectedSession(int)), this, SLOT(setColourtableSession(int)));
	connect(_colourscale_colour_bar_disp_fld, SIGNAL(valueChanged(double)), this, SLOT(setColourbarDisplacement(double)));
	connect( _colourscale_label_fld, SIGNAL(textChanged(const QString &)), this, SLOT(setColourScaleLabel()) );
	setSlotColour(false);
	connect( _colourscale_autolabel_fld, SIGNAL(toggled(bool)), this, SLOT(setColourScaleAutoLabelToggle(bool)) );
	connect(_colourscale_ticklength_fld, SIGNAL(valueChanged(double)), this, SLOT(setTicksLength(double)));
    connect( _exp_label_offset_y_fld, SIGNAL(valueChanged(double)), this, SLOT(setAxisExpLabelYOffset(double)));
    connect( _exp_label_offset_x_fld, SIGNAL(valueChanged(double)), this, SLOT(setAxisExpLabelXOffset(double)));
}

QpColourscaleTab::QpColourscaleTab(QpColourscaleTab* tab, SpectrumItem* _spectro):
	QpTab((QTabWidget*)(tab->parent()), "ColourscaleTab", QP_COLOUR_TAB)
{
		// Constructor for the Colour Scale Tab widget shown in the SpectroGram Options

	I_Spectrum = _spectro;
	
	create();
	
	_colourscale_auto_fld->setCurrentIndex(tab->_colourscale_auto_fld->currentIndex());
	_colourscale_min_fld->setDouble(tab->_colourscale_min_fld->value());
	_colourscale_max_fld->setDouble(tab->_colourscale_max_fld->value());
	_colourscale_linlog_fld->setCurrentIndex(tab->_colourscale_linlog_fld->currentIndex());
// 	_colourscale_table_fld->setCurrentItem(tab->_colourscale_table_fld->currentItem()); //TODO
	_colourscale_label_fld->setText(tab->_colourscale_label_fld->text());
	_colourscale_show_colour_bar_fld->setChecked(tab->_colourscale_show_colour_bar_fld->isChecked());
	_colourscale_colour_bar_width_fld->setValue(tab->_colourscale_colour_bar_width_fld->value());
	_colourscale_colour_bar_disp_fld->setValue(tab->_colourscale_colour_bar_disp_fld->value());
	_colourscale_autolabel_fld->setChecked(tab->_colourscale_autolabel_fld->isChecked());
	_colourscale_colour_bar_height_fld->setValue(tab->_colourscale_colour_bar_height_fld->value());
	_colourscale_colour_bar_voffset_fld->setValue(tab->_colourscale_colour_bar_voffset_fld->value());
	_colourscale_ticklength_fld->setValue(tab->_colourscale_ticklength_fld->value());

	connect( _colourscale_auto_fld, SIGNAL(activated(int)), this, SLOT(setAutoScale(int)) );
	connect( _colourscale_linlog_fld, SIGNAL(activated(int)), this, SLOT(setLinLog(int)) );
	connect( _colourscale_min_fld, SIGNAL(edited_OK()), this, SLOT(setColourScaleMin()) );
	connect( _colourscale_max_fld, SIGNAL(edited_OK()), this, SLOT(setColourScaleMax()) );
	connect( _colourscale_show_colour_bar_fld, SIGNAL(toggled(bool)), this, SLOT(setShowColourBar(bool)) );
	connect(_colourscale_colour_bar_width_fld, SIGNAL(valueChanged(double)), this, SLOT(setColourbarWidth(double)));
	connect(_colourscale_colour_bar_height_fld, SIGNAL(valueChanged(double)), this, SLOT(setColourbarHeight(double)));
	connect(_colourscale_colour_bar_voffset_fld, SIGNAL(valueChanged(double)), this, SLOT(setColourbarVoffset(double)));
// 	connect( _colourscale_table_fld, SIGNAL(activated(int)), this, SLOT(setColourtable(int)) );
    connect(_colourtable_fld, SIGNAL(selectedStd(int)), this, SLOT(setColourtableStd(int)));
    connect(_colourtable_fld, SIGNAL(selectedProfile(int)), this, SLOT(setColourtableProfile(int)));
    connect(_colourtable_fld, SIGNAL(selectedSession(int)), this, SLOT(setColourtableSession(int)));
	connect(_colourscale_colour_bar_disp_fld, SIGNAL(valueChanged(double)), this, SLOT(setColourbarDisplacement(double)));
	connect( _colourscale_label_fld, SIGNAL(textChanged(const QString &)), this, SLOT(setColourScaleLabel()) );
	setSlotColour(false);
	connect( _colourscale_autolabel_fld, SIGNAL(toggled(bool)), this, SLOT(setColourScaleAutoLabelToggle(bool)) );
	connect(_colourscale_ticklength_fld, SIGNAL(valueChanged(double)), this, SLOT(setTicksLength(double)));
    connect( _exp_label_offset_y_fld, SIGNAL(valueChanged(double)), this, SLOT(setAxisExpLabelYOffset(double)));
    connect( _exp_label_offset_x_fld, SIGNAL(valueChanged(double)), this, SLOT(setAxisExpLabelXOffset(double)));
}

void QpColourscaleTab::create()
{
	QVBoxLayout *colourscale_top_layout = new QVBoxLayout(this);
	colourscale_top_layout->setSpacing(QSAS_profiles->current()->GUImargins);
	colourscale_top_layout->setMargin(QSAS_profiles->current()->GUImargins);

	QGroupBox *colourscale_scale_groupbox = new QGroupBox(this);

	colourscale_scale_groupbox->setTitle("Scale");

	QGridLayout *colourscale_scale_layout=new QGridLayout;
	colourscale_scale_layout->setSpacing(QSAS_profiles->current()->GUImargins);
	colourscale_scale_layout->setMargin(QSAS_profiles->current()->GUImargins);

	QLabel* auto_label=new QLabel("Use: ");
	colourscale_scale_layout->addWidget(auto_label, 1, 0, Qt::AlignRight);	
	_colourscale_auto_fld = new QComboBox();
	_colourscale_auto_fld->insertItem(QP_FROM_META, "Metadata");
	_colourscale_auto_fld->insertItem(QP_FROM_DATA, "Autoscale");
	_colourscale_auto_fld->insertItem(QP_FROM_USER, "User Set");
	colourscale_scale_layout->addWidget(_colourscale_auto_fld, 1, 1, Qt::AlignLeft);

	QLabel* linlog_label=new QLabel("  Type: ");
	colourscale_scale_layout->addWidget(linlog_label, 1, 2, Qt::AlignRight);
	_colourscale_linlog_fld = new QComboBox();
	_colourscale_linlog_fld->insertItem(QP_LINEAR, "Linear");
	_colourscale_linlog_fld->insertItem(QP_LOG, "Log");
	QFontMetrics cs_linlog_fm(_colourscale_linlog_fld->font());
	int cs_linlog_w = cs_linlog_fm.width("Linear");
	int cs_linlog_h = cs_linlog_fm.height();
	_colourscale_linlog_fld->setMinimumSize(cs_linlog_w, cs_linlog_h);

	_colourscale_linlog_fld->setToolTip("Select linear or log scaling");
	colourscale_scale_layout->addWidget(_colourscale_linlog_fld, 1, 3, Qt::AlignLeft);

	QLabel* min_label = new QLabel("Min: ");
	colourscale_scale_layout->addWidget(min_label,3,0,Qt::AlignRight);
	_colourscale_min_fld = new QguWLinput(colourscale_scale_groupbox, "colourscale_min");
	_colourscale_min_fld->setFixedWidth(120);
	_colourscale_min_fld->setAcceptable(Qcondition(QS_NARROW, QS_DBL, QS_0D, QS_NOT_SEQ, QS_ANY));
	setSlotColour(false);
	_colourscale_min_fld->lineBox->setPalette(GUIpalette);
	colourscale_scale_layout->addWidget(_colourscale_min_fld, 3, 1, Qt::AlignLeft);

	QLabel* max_label=new QLabel("Max: ");
	colourscale_scale_layout->addWidget(max_label,3,2,Qt::AlignRight);
	_colourscale_max_fld = new QguWLinput(colourscale_scale_groupbox, "colourscale_max");
	_colourscale_max_fld->setFixedWidth(120);
	_colourscale_max_fld->setAcceptable(Qcondition(QS_NARROW, QS_DBL, QS_0D, QS_NOT_SEQ, QS_ANY));
	setSlotColour(false);
	_colourscale_max_fld->lineBox->setPalette(GUIpalette);
	colourscale_scale_layout->addWidget(_colourscale_max_fld, 3, 3, Qt::AlignLeft);

    QGroupBox* _exp_label_params_groupbox=new QGroupBox("Exponential label position");

    QHBoxLayout * exp_layout=new QHBoxLayout;
    
    exp_layout->addWidget(new QLabel("Horizontal offset:"), Qt::AlignRight);

    _exp_label_offset_x_fld=new FloatSpinBox(-20., 20., 2, 0.02);
    exp_layout->addWidget(_exp_label_offset_x_fld,Qt::AlignLeft);
	_exp_label_offset_x_fld->setValue(0.);

    exp_layout->addWidget(new QLabel("Vertical offset:"), Qt::AlignRight);

    _exp_label_offset_y_fld=new FloatSpinBox(-20., 20., 2, 0.02);
    exp_layout->addWidget(_exp_label_offset_y_fld, Qt::AlignLeft);
	_exp_label_offset_y_fld->setValue(0.);

    exp_layout->addStretch(10);
    
    _exp_label_params_groupbox->setLayout(exp_layout);

    colourscale_scale_layout->addWidget(_exp_label_params_groupbox, 5, 0, 1, 4);

	colourscale_scale_layout->setRowStretch(0,0);
	colourscale_scale_layout->setRowStretch(1,1);
	colourscale_scale_layout->setRowStretch(2,0);
	colourscale_scale_layout->setRowStretch(3,1);
	colourscale_scale_layout->setRowStretch(4,0);
    colourscale_scale_layout->setRowStretch(5,1);

	colourscale_scale_layout->setColumnStretch(0,0);
	colourscale_scale_layout->setColumnStretch(1,0);
	colourscale_scale_layout->setColumnStretch(2,0);
	colourscale_scale_layout->setColumnStretch(3,0);
	colourscale_scale_layout->setColumnStretch(4,1);
	
	colourscale_scale_groupbox->setLayout(colourscale_scale_layout);

	colourscale_top_layout->addWidget(colourscale_scale_groupbox);

	QGroupBox *colourscale_colour_bar_groupbox=new QGroupBox(this);

	colourscale_colour_bar_groupbox->setTitle("Colour Bar");

	QGridLayout *colourscale_colour_bar_layout = new QGridLayout;
	colourscale_colour_bar_layout->setSpacing(QSAS_profiles->current()->GUImargins);
	colourscale_colour_bar_layout->setMargin(QSAS_profiles->current()->GUImargins);

	_colourscale_show_colour_bar_fld = new QCheckBox("Show colour bar");
	_colourscale_show_colour_bar_fld->setChecked(true);
	colourscale_colour_bar_layout->addWidget( _colourscale_show_colour_bar_fld, 1, 0, Qt::AlignLeft);

	QLabel* colourscale_colour_bar_width = new QLabel("Width: ");
	colourscale_colour_bar_layout->addWidget( colourscale_colour_bar_width, 3, 0, Qt::AlignRight);
	_colourscale_colour_bar_width_fld = new FloatSpinBox( 0.01, 40., 1, .5, colourscale_colour_bar_groupbox, "colour_bar_width");
	_colourscale_colour_bar_width_fld->setFixedWidth(100);
	colourscale_colour_bar_layout->addWidget( _colourscale_colour_bar_width_fld, 3, 1, Qt::AlignLeft);

	_colourscale_colour_bar_width_fld->setValue(QPUI_COLOUR_BAR_WIDTH);

	QLabel* colourscale_colour_bar_height = new QLabel("Height Fraction: ");
	colourscale_colour_bar_layout->addWidget( colourscale_colour_bar_height, 3, 3, Qt::AlignRight);
	_colourscale_colour_bar_height_fld = new FloatSpinBox( 0.2,10.,2,.2,colourscale_colour_bar_groupbox, "colour_bar_height");
	_colourscale_colour_bar_height_fld->setFixedWidth(100);
	colourscale_colour_bar_layout->addWidget( _colourscale_colour_bar_height_fld, 3, 4, Qt::AlignLeft);
	_colourscale_colour_bar_height_fld->setValue(QPUI_COLOUR_BAR_HEIGHT);
	
	QLabel* colourscale_colour_bar_voffset = new QLabel("Vertical Offset: ");
	colourscale_colour_bar_layout->addWidget( colourscale_colour_bar_voffset, 5, 3, Qt::AlignRight);
	_colourscale_colour_bar_voffset_fld = new FloatSpinBox( -10., 10., 2, .2, colourscale_colour_bar_groupbox, "colour_bar_voffset");
	_colourscale_colour_bar_voffset_fld->setFixedWidth(100);
	colourscale_colour_bar_layout->addWidget( _colourscale_colour_bar_voffset_fld, 5, 4, Qt::AlignLeft);

	_colourscale_colour_bar_voffset_fld->setValue(QPUI_COLOUR_BAR_VOFFSET);
	
	QLabel* colour_table_label = new QLabel("Colour Table: ");
	colourscale_colour_bar_layout->addWidget(colour_table_label, 1, 3, Qt::AlignRight);

    _colourtable_fld=new ColourTableButton;
    colourscale_colour_bar_layout->addWidget(_colourtable_fld, 1, 4, Qt::AlignLeft);

	QLabel* colourscale_colour_bar_disp = new QLabel("Displacement: ");
	colourscale_colour_bar_layout->addWidget( colourscale_colour_bar_disp, 5, 0, Qt::AlignRight);
	_colourscale_colour_bar_disp_fld = new FloatSpinBox( 0.01,40.,1,.5,colourscale_colour_bar_groupbox, "colour_bar_disp");
	_colourscale_colour_bar_disp_fld->setFixedWidth(100);
	colourscale_colour_bar_layout->addWidget( _colourscale_colour_bar_disp_fld, 5, 1, Qt::AlignLeft);
    _colourscale_colour_bar_disp_fld->setValue(QPUI_COLOUR_BAR_DISP);

	QLabel* colourscale_ticklength_disp=new QLabel("Ticks length: ");
	colourscale_colour_bar_layout->addWidget(colourscale_ticklength_disp, 7, 0, Qt::AlignRight);
	_colourscale_ticklength_fld= new FloatSpinBox(0.01, 40., 1, .5, this, "ticks_length");
	_colourscale_ticklength_fld->setFixedWidth(100);
	colourscale_colour_bar_layout->addWidget( _colourscale_ticklength_fld, 7, 1, Qt::AlignLeft);
	_colourscale_ticklength_fld->setValue(QPUI_TICKS_LENGTH);

	colourscale_colour_bar_layout->setRowStretch(0,0);
	colourscale_colour_bar_layout->setRowStretch(1,1);
	colourscale_colour_bar_layout->setRowStretch(2,0);
	colourscale_colour_bar_layout->setRowStretch(3,1);
	colourscale_colour_bar_layout->setRowStretch(4,0);

	colourscale_colour_bar_layout->setColumnStretch(0,0);
	colourscale_colour_bar_layout->setColumnStretch(1,0);
	colourscale_colour_bar_layout->setColumnStretch(2,0);
	colourscale_colour_bar_layout->setColumnStretch(3,0);
	colourscale_colour_bar_layout->setColumnStretch(4,1);
	colourscale_colour_bar_layout->setColumnStretch(5,0);
	colourscale_colour_bar_layout->setColumnStretch(6,1);
	
	colourscale_colour_bar_groupbox->setLayout(colourscale_colour_bar_layout);

	colourscale_top_layout->addWidget(colourscale_colour_bar_groupbox);

	QGroupBox *colourscale_label_groupbox = new QGroupBox(this);
	colourscale_label_groupbox->setTitle("Label");

	QGridLayout *colourscale_label_layout = new QGridLayout;
	colourscale_label_layout->setSpacing(QSAS_profiles->current()->GUImargins);
	colourscale_label_layout->setMargin(QSAS_profiles->current()->GUImargins);

	_colourscale_label_fld = new QLineEdit;
	_colourscale_label_fld->setMinimumWidth(350);
	colourscale_label_layout->addWidget(_colourscale_label_fld, 1, 0, 1, 4, Qt::AlignLeft);
	setSlotColour(false);
	_colourscale_label_fld->setPalette(GUIpalette);
	
	_colourscale_autolabel_fld = new QCheckBox( "Auto-label");
	_colourscale_autolabel_fld->setChecked(true);
	colourscale_label_layout->addWidget(_colourscale_autolabel_fld, 1, 4, Qt::AlignLeft);
	colourscale_label_layout->setRowStretch(0,0);
	colourscale_label_layout->setRowStretch(1,1);
	colourscale_label_layout->setRowStretch(2,0);

	colourscale_label_layout->setColumnStretch(0,0);
	colourscale_label_layout->setColumnStretch(1,0);
	colourscale_label_layout->setColumnStretch(2,0);
	colourscale_label_layout->setColumnStretch(3,0);
	colourscale_label_layout->setColumnStretch(4,1);
	
	colourscale_label_groupbox->setLayout(colourscale_label_layout);

	colourscale_top_layout->addWidget(colourscale_label_groupbox);

	colourscale_top_layout->addSpacing(4);
	colourscale_top_layout->addStretch(10);
	
	colour_auto_last = QP_FROM_META;
}

void QpColourscaleTab::setColourScaleMin()
{
	if ( QuSlotDebug() )
	{
		printf( "QpColourscaleTab::setColourScaleMin  \n" );
		fflush(stdout);
	}
	if(_colourscale_min_fld->lineBox->hasFocus())
	{
		// only change if user input
		QString value_str = _colourscale_min_fld->text();
		_colourscale_auto_fld->setCurrentIndex(QP_FROM_USER);
		setSlotColour(true);
		_colourscale_min_fld->lineBox->setPalette(GUIpalette);
		_colourscale_max_fld->lineBox->setPalette(GUIpalette);
		
		// set flag for next time (used in getZRange methods)
		colour_auto_last = _colourscale_auto_fld->currentIndex();
	
		float value = (float) string_to_double(value_str.toLatin1().data());
		// propagate to other spectrum Items
 		if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_MIN, 0, value);
	}
	
}

void QpColourscaleTab::setColourScaleMax()
{
	if ( QuSlotDebug() )
	{
		printf( "QpColourscaleTab::setColourScaleMax \n" );
		fflush(stdout);
	}

	if(_colourscale_max_fld->lineBox->hasFocus())
	{
		// only change if user input
		QString value_str = _colourscale_max_fld->text();
		_colourscale_auto_fld->setCurrentIndex(QP_FROM_USER);
		setSlotColour(true);
		_colourscale_min_fld->lineBox->setPalette(GUIpalette);
		_colourscale_max_fld->lineBox->setPalette(GUIpalette);
		
		// set flag for next time (used in getZRange methods)
		colour_auto_last = _colourscale_auto_fld->currentIndex();
				
		float value = (float) string_to_double(value_str.toLatin1().data());
		// propagate to other spectrum Items
 		if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_MAX, 0, value);

	}	
}


void QpColourscaleTab::setColourScaleLabel()
{
	if ( QuSlotDebug() )
	{
		printf( "QpColourscaleTab::setColourScaleLabel \n");
		fflush(stdout);
	}

	if(_colourscale_label_fld->hasFocus())
	{
		// only change if user input
		QString txt	= _colourscale_label_fld->text();
		_colourscale_autolabel_fld->setChecked(false);
		
		// propagate to other spectrum Items
 		if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_LABEL, 0, 0.0, txt);

	}	
}


// ---------------------------------------

void QpColourscaleTab::setColourScaleAutoLabelToggle(bool On)
{
	if(On)
	{
		_colourscale_label_fld->clearFocus();		

		setColourScaleAutoLabel();
	}
	setSlotColour(!On);
	_colourscale_label_fld->setPalette(GUIpalette);

	// propagate to other spectrum Items
 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_AUTOLABEL, 0, 0.0, "", On);

}

void QpColourscaleTab::setTicksLength(double val)
{
	// propagate to other spectrum Items
	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_TICK_LENGTH, 0, val);
}

void QpColourscaleTab::setAxisExpLabelXOffset(double val)
{
    // propogate to other spectrum Items
    if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_AXIS_EXP_LABEL_X, 0, val);
}

void QpColourscaleTab::setAxisExpLabelYOffset(double val)
{
    // propogate to other spectrum Items
    if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_AXIS_EXP_LABEL_Y, 0, val);
}

// ---------------------------------------

void QpColourscaleTab::setColourScaleAutoLabel()
{
	if( !(_colourscale_autolabel_fld->isChecked()) ) return;
	
	string defaultLabel="";
	I_Spectrum->panel()->getLabel(COL_AXIS, defaultLabel);
	_colourscale_label_fld->setText(defaultLabel.c_str());
}

// ---------------------------------------

void QpColourscaleTab::setColourbarWidth(double width)
{
	// propagate to other spectrum Items
 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_COLOUR_BAR_WIDTH, 0, width);
}

// ---------------------------------------

void QpColourscaleTab::setColourbarVoffset(double offset)
{
	// propagate to other spectrum Items
 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_COLOUR_BAR_VOFFSET, 0, offset);
}

// ---------------------------------------

void QpColourscaleTab::setColourbarHeight(double height)
{
	// propagate to other spectrum Items
 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_COLOUR_BAR_HEIGHT, 0, height);
}
// ---------------------------------------

void QpColourscaleTab::setColourbarDisplacement(double disp)
{
	// propagate to other spectrum Items
 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_COLOUR_BAR_DISP, 0, disp);
}

// ---------------------------------------

// void QpColourscaleTab::setColourtable(int choice)
// {
// 	// propogate to other spectrum Items
//  	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_TABLE, choice);
// 
// }

void QpColourscaleTab::setColourtableStd(int choice)
{

    // propogate to other spectrum Items
    if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_TABLE_STD, choice);

}

void QpColourscaleTab::setColourtableProfile(int choice)
{
    // propogate to other spectrum Items
    if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_TABLE_PROFILE, choice);

}

void QpColourscaleTab::setColourtableSession(int choice)
{
    // propogate to other spectrum Items
    if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_TABLE_SESSION, choice);

}

// ---------------------------------------

void QpColourscaleTab::setAutoScale(int iChoice)
{
	if(iChoice == QP_FROM_USER)
	{
		setSlotColour(true);
	}
	else 
	{
		_colourscale_min_fld->clearFocus();
		_colourscale_max_fld->clearFocus();
		setColourscaleMinMax();

		qApp->processEvents();

		setSlotColour(false);
	}
	
	_colourscale_min_fld->lineBox->setPalette(GUIpalette);
	_colourscale_max_fld->lineBox->setPalette(GUIpalette);
	
	// set flag for next time (used in getZRange methods)
	colour_auto_last = _colourscale_auto_fld->currentIndex();
	
	// propagate to other spectrum Items
 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_AUTOSCALE, iChoice);

}

// ---------------------------------------

void QpColourscaleTab::setLinLog(int choice)
{
	// tell auto field user set
	_colourscale_auto_fld->setCurrentIndex(QP_FROM_USER);
	
	// propagate to other spectrum Items
 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_LINLOG, choice);

}
// ---------------------------------------

void QpColourscaleTab::setShowColourBar(bool On)
{

	// propagate to other spectrum Items
 	if(this->isVisible() ) I_Spectrum->root()->I_PlotView->setSpectrumOption(COLOUR_SCALE_SHOW_COLOUR_BAR, 0, 0.0, "", On);

}

// ---------------------------------------

void QpColourscaleTab::setColourscaleMinMax()
{
	
	if ( QuSlotDebug() )
	{
		printf( "QpColourscaleTab::setColourscaleMinMax \n");
		fflush(stdout);
	}

	switch( _colourscale_auto_fld->currentIndex())
	{
	
		case QP_FROM_META:
		{
			
			// Set Colourscale if Use Metadata is on
			double _min=0, _max=0;
			if( I_Spectrum->getZmetaRange(_min, _max) )
			{
				_colourscale_min_fld->setText(double_to_string(_min).c_str());
				_colourscale_max_fld->setText(double_to_string(_max).c_str());
				 break;
			}
			// else fall through and use data

		}
		case QP_FROM_DATA: 
		{
			//  Set Colour Scale range if use autoscale is on

			// set wait cursor - could be a delay if large datasets
			QApplication::setOverrideCursor( QCursor(Qt::WaitCursor) );

			qApp->processEvents();
   
			bool rangeOK;
	
			double _min, _max;
			rangeOK = I_Spectrum->getZRange(_min, _max);
			
			// refresh from and to fields
			if(rangeOK)
			{
				_colourscale_min_fld->setText(double_to_string(_min).c_str());
				_colourscale_max_fld->setText(double_to_string(_max).c_str());
			}
			else
			{
				_colourscale_min_fld->setText("");
				_colourscale_max_fld->setText("");
			}
	    
   
			// restore cursor
			QApplication::restoreOverrideCursor();

			qApp->processEvents();

		}
		case QP_FROM_USER: Default:
		{
				// do nothing
		}
	}

}

QDomElement QpColourscaleTab::toXMLElement(QDomDocument& doc) const
{
    QDomElement xml=doc.createElement("Colourscale_Tab");
    xml.appendChild(createTextXMLNode(doc, "Auto", _colourscale_auto_fld->currentIndex()));
    xml.appendChild(createTextXMLNode(doc, "Min", _colourscale_min_fld->value()));
    xml.appendChild(createTextXMLNode(doc, "Max", _colourscale_max_fld->value()));
    xml.appendChild(createTextXMLNode(doc, "Lin_Log", _colourscale_linlog_fld->currentIndex()));
    xml.appendChild(createTextXMLNode(doc, "Exp_Label_X", _exp_label_offset_x_fld->value()));
    xml.appendChild(createTextXMLNode(doc, "Exp_Label_Y", _exp_label_offset_y_fld->value()));

    ColourTable colourTable=_colourtable_fld->getCurrentTable();

    int _colour_table_type;
    int _colour_table_id;
    if(stdPalette.contains(colourTable))
    {
        _colour_table_type=0;
        _colour_table_id=stdPalette.indexOf(colourTable);
    }
    else
    {
        _colour_table_type=1;
        _colour_table_id=savedPalette.indexOf(colourTable);
    }
    xml.appendChild(createTextXMLNode(doc, "Colour_Table_Type", _colour_table_type));
    xml.appendChild(createTextXMLNode(doc, "Colour_Table_ID", _colour_table_id));
    xml.appendChild(createTextXMLNode(doc, "Label", _colourscale_label_fld->text()));
    xml.appendChild(createTextXMLNode(doc, "Show_Colour_Bar", _colourscale_show_colour_bar_fld->isChecked()));
    xml.appendChild(createTextXMLNode(doc, "Colour_Bar_Width", _colourscale_colour_bar_width_fld->value()));
    xml.appendChild(createTextXMLNode(doc, "Colour_Bar_Displacement", _colourscale_colour_bar_disp_fld->value()));
    xml.appendChild(createTextXMLNode(doc, "Autolabel", _colourscale_autolabel_fld->isChecked()));
    xml.appendChild(createTextXMLNode(doc, "Colour_Bar_Height", _colourscale_colour_bar_height_fld->value()));
    xml.appendChild(createTextXMLNode(doc, "Colour_Bar_V_Offset", _colourscale_colour_bar_voffset_fld->value()));
    xml.appendChild(createTextXMLNode(doc, "Colour_Bar_Tick_Length", _colourscale_ticklength_fld->value()));
    

    return xml;
}

void QpColourscaleTab::fromXMLElement(QDomElement& el)
{
    QString s;
    
    if(getXMLNodeText(el, "Auto", s))
    {
        _colourscale_auto_fld->setCurrentIndex(s.toInt());
    }
    if(getXMLNodeText(el, "Min", s))
    {
        _colourscale_min_fld->setDouble(s.toDouble());
    }
    if(getXMLNodeText(el, "Max", s))
    {
        _colourscale_max_fld->setDouble(s.toDouble());
    }
    if(getXMLNodeText(el, "Lin_Log", s))
    {
        _colourscale_linlog_fld->setCurrentIndex(s.toInt());
    }
    if(getXMLNodeText(el, "Exp_Label_X", s))
    {
        _exp_label_offset_x_fld->setValue(s.toDouble());
    }
    if(getXMLNodeText(el, "Exp_Label_Y", s))
    {
        _exp_label_offset_y_fld->setValue(s.toDouble());
    }

    int _colour_table_type(0);
    int _colour_table(0);
    if(getXMLNodeText(el, "Colour_Table_ID", s))
    {
        _colour_table=s.toInt();
    }
    if(getXMLNodeText(el, "Colour_Table_Type", s))
    {
        _colour_table_type=(s.toInt());
    }
    if(_colour_table_type!=0)
    {
        _colourtable_fld->setSessionPalette(_colour_table+importedPaletteOffset);
    }
    else
    {
        _colourtable_fld->setStdPalette(_colour_table);
    }

    if(getXMLNodeText(el, "Label", s))
    {
        _colourscale_label_fld->setText(s);
    }
    if(getXMLNodeText(el, "Show_Colour_Bar", s))
    {
        _colourscale_show_colour_bar_fld->setChecked((bool)s.toInt());
    }
    if(getXMLNodeText(el, "Colour_Bar_Width", s))
    {
        _colourscale_colour_bar_width_fld->setValue(s.toDouble());
    }
    if(getXMLNodeText(el, "Colour_Bar_Displacement", s))
    {
        _colourscale_colour_bar_disp_fld->setValue(s.toDouble());
    }
    if(getXMLNodeText(el, "Autolabel", s))
    {
        _colourscale_autolabel_fld->setChecked((bool)s.toInt());
    }
    if(getXMLNodeText(el, "Colour_Bar_Height", s))
    {
        _colourscale_colour_bar_height_fld->setValue(s.toDouble());
    }
    if(getXMLNodeText(el, "Colour_Bar_V_Offset", s))
    {
        _colourscale_colour_bar_voffset_fld->setValue(s.toDouble());
    }
    if(getXMLNodeText(el, "Colour_Bar_Tick_Length", s))
    {
        _colourscale_ticklength_fld->setValue(s.toDouble());
    }
}

